@echo off

SETLOCAL

title Increment Shared Dll Counter ...

set SHAREDDLLSKEY=HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\SharedDlls
set FULLPATH=%1

:: check if shared counter for the given file exists
REG QUERY "%SHAREDDLLSKEY%" /v %FULLPATH% >nul 2>nul

if errorlevel 1 GOTO ADDVALUE

GOTO INCREMENTVALUE

:ADDVALUE

:: add shared counter, value=1
REG ADD "%SHAREDDLLSKEY%" /v %FULLPATH% /t REG_DWORD /d 1 /f >nul 2>nul

goto END1

:INCREMENTVALUE

set COUNT=	

:: get shared dll counter value
:: output of REG QUERY is different, e.g. XP uses TABs as delimiters, Vista uses Blanks
FOR /F "tokens=2,3,4,5* delims=	 " %%A IN ('REG QUERY "%SHAREDDLLSKEY%" /v %FULLPATH%') DO (
	:: the next token after REG_DWORD is the count we are looking for
	if %%A==REG_DWORD set COUNT=%%B
	if %%B==REG_DWORD set COUNT=%%C
	if %%C==REG_DWORD set COUNT=%%D
	if %%D==REG_DWORD set COUNT=%%E
)

:: set incremented shared dll counter value
set /a NEWCOUNT=%COUNT%+1
REG ADD "%SHAREDDLLSKEY%" /v %FULLPATH% /t REG_DWORD /d %NEWCOUNT% /f >nul 2>nul

:END1
